/****************************************************************************
 *
 * Julia set test program for PS3 cell architecture.
 *
 * (c) 2007 Ranulf Doswell <dev@ranulf.net>
 *
 * I've only been programming the PS3 for just over 24 hours and here is my
 * first attempt at just the SPUs, DMA transfers and hand-optimising SBU
 * assembler (such a nice processor to experiment with)...
 *
 * Please feel free to use this as a basis for your experimentations, but if
 * you come up with anything cool, please let me know!
 *
 ****************************************************************************/

	.file	"julia_spe.c"


/* This is the compiled version of julia_spe.c, but with the juliaLine and
   julia methods removed, because I've worked on them specifically in
   optimised.s

   The main reason for seperating this out was I was having problems with
   DMA transfers when attempting to use messages to signal between PPE and
   SPE, so was switching between the two versions (which is easy from a C
   perspective, but trickier as I was trying to edit the same file.
 */
	.section	.rodata
	.align	4
.LC0:
	.string	"[%lld] terminating\n"
.text
	.align	3
	.global	main
	.type	main, @function
main:
	stqd	$lr,16($sp)
	stqd	$sp,-624($sp)
	il	$2,-624
	a	$sp,$sp,$2
	lqd	$2,560($sp)
	cdd	$6,0($sp)
	shufb	$2,$3,$2,$6
	stqd	$2,560($sp)
	lqd	$2,576($sp)
	cdd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,576($sp)
	lqd	$2,592($sp)
	cdd	$3,0($sp)
	shufb	$2,$5,$2,$3
	stqd	$2,592($sp)
	il	$4,0
	lqd	$2,480($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,480($sp)
.L15:
	rdch	$2,$ch29
	ori	$4,$2,0
	lqd	$2,464($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,464($sp)
	lqd	$2,464($sp)
	cgti	$2,$2,-1
	brnz	$2,.L16
	ila	$3,.LC0
	lqd	$4,560($sp)
	brsl	$lr,printf
	il	$2,0
	stqd	$2,608($sp)
	br	.L14
.L16:
	lqd	$2,480($sp)
	ai	$3,$2,1
	rotmai	$2,$3,-31
	xor	$3,$3,$2
	sf	$3,$2,$3
	andi	$3,$3,31
	xor	$3,$3,$2
	sf	$4,$2,$3
	lqd	$2,480($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,480($sp)
	lqd	$2,576($sp)
	rotqmbyi	$2,$2,-4
	rotqmbii	$2,$2,0
	shlqbyi	$5,$2,4
	lqd	$2,576($sp)
	shlqbyi	$6,$2,4
	lqd	$7,480($sp)
	ai	$4,$sp,496
	lqd	$2,224($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,224($sp)
	lqd	$2,240($sp)
	cwd	$3,0($sp)
	shufb	$2,$5,$2,$3
	stqd	$2,240($sp)
	lqd	$2,256($sp)
	cwd	$3,0($sp)
	shufb	$2,$6,$2,$3
	stqd	$2,256($sp)
	il	$4,64
	lqd	$2,272($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,272($sp)
	lqd	$2,288($sp)
	cwd	$3,0($sp)
	shufb	$2,$7,$2,$3
	stqd	$2,288($sp)
	il	$4,64
	lqd	$2,304($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,304($sp)
	lqd	$2,224($sp)
	wrch	$ch16,$2
	lqd	$2,240($sp)
	wrch	$ch17,$2
	lqd	$2,256($sp)
	wrch	$ch18,$2
	lqd	$2,272($sp)
	wrch	$ch19,$2
	lqd	$2,288($sp)
	wrch	$ch20,$2
	lqd	$2,304($sp)
	wrch	$ch21,$2
	il	$3,1
	lqd	$2,480($sp)
	shl	$2,$3,$2
	wrch	$ch22,$2
	il	$2,1
	wrch	$ch23,$2
	rdch	$2,$ch24
	ori	$4,$2,0
	lqd	$2,448($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,448($sp)
	il	$2,42
	wrch	$ch28,$2
	lqd	$2,528($sp)
	rotqbyi	$3,$2,4
	lqd	$2,544($sp)
	rotqbyi	$2,$2,4
	mpyh	$5,$3,$2
	mpyh	$4,$2,$3
	mpyu	$3,$3,$2
	a	$2,$5,$4
	a	$2,$2,$3
	shli	$4,$2,2
	lqd	$2,432($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,432($sp)
	lqd	$2,432($sp)
	ori	$3,$2,0
	brsl	$lr,malloc
	ori	$2,$3,0
	ori	$4,$2,0
	lqd	$2,416($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,416($sp)
	lqd	$4,528($sp)
	lqd	$2,400($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,400($sp)
	lqd	$2,528($sp)
	rotqbyi	$2,$2,4
	shli	$4,$2,2
	lqd	$2,384($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,384($sp)
	lqd	$4,496($sp)
	lqd	$2,544($sp)
	csflt	$3,$2,0
	lqd	$2,512($sp)
	rotqbyi	$2,$2,8
	fm	$2,$3,$2
	fa	$4,$4,$2
	lqd	$2,368($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,368($sp)
	lqd	$2,496($sp)
	rotqbyi	$4,$2,4
	lqd	$2,544($sp)
	csflt	$3,$2,0
	lqd	$2,512($sp)
	rotqbyi	$2,$2,12
	fm	$2,$3,$2
	fa	$4,$4,$2
	lqd	$2,352($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,352($sp)
	il	$4,0
	lqd	$2,320($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,320($sp)
	br	.L18
.L19:
	lqd	$4,368($sp)
	lqd	$2,208($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,208($sp)
	lqd	$4,352($sp)
	lqd	$2,192($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,192($sp)
	lqd	$2,512($sp)
	rotqbyi	$3,$2,8
	lqd	$2,368($sp)
	fa	$4,$2,$3
	lqd	$2,368($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,368($sp)
	lqd	$2,512($sp)
	rotqbyi	$3,$2,12
	lqd	$2,352($sp)
	fa	$4,$2,$3
	lqd	$2,352($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,352($sp)
	lqd	$2,528($sp)
	rotqbyi	$3,$2,4
	lqd	$2,320($sp)
	mpyh	$5,$3,$2
	mpyh	$4,$2,$3
	mpyu	$3,$3,$2
	a	$2,$5,$4
	a	$2,$2,$3
	shli	$2,$2,2
	ori	$3,$2,0
	lqd	$2,416($sp)
	a	$4,$3,$2
	lqd	$2,176($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,176($sp)
	lqd	$3,544($sp)
	lqd	$2,320($sp)
	a	$3,$3,$2
	lqd	$2,528($sp)
	rotqbyi	$2,$2,4
	mpyh	$5,$3,$2
	mpyh	$4,$2,$3
	mpyu	$3,$3,$2
	a	$2,$5,$4
	a	$2,$2,$3
	shli	$2,$2,2
	ori	$3,$2,0
	lqd	$2,400($sp)
	a	$4,$3,$2
	lqd	$2,160($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,160($sp)
	lqd	$2,528($sp)
	rotqbyi	$4,$2,4
	lqd	$2,496($sp)
	rotqbyi	$7,$2,8
	lqd	$2,496($sp)
	rotqbyi	$8,$2,12
	lqd	$9,512($sp)
	lqd	$2,512($sp)
	rotqbyi	$2,$2,4
	lqd	$3,176($sp)
	lqd	$5,208($sp)
	lqd	$6,192($sp)
	ori	$10,$2,0
	brsl	$lr,juliaLine
	lqd	$2,480($sp)
	ai	$3,$2,1
	rotmai	$2,$3,-31
	xor	$3,$3,$2
	sf	$3,$2,$3
	andi	$3,$3,31
	xor	$3,$3,$2
	sf	$4,$2,$3
	lqd	$2,480($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,480($sp)
	lqd	$2,160($sp)
	rotqmbyi	$4,$2,-4
	lqd	$2,144($sp)
	cdd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,144($sp)
	lqd	$2,144($sp)
	rotqmbyi	$2,$2,-4
	rotqmbii	$2,$2,0
	shlqbyi	$5,$2,4
	lqd	$2,144($sp)
	shlqbyi	$6,$2,4
	lqd	$7,384($sp)
	lqd	$8,480($sp)
	lqd	$4,176($sp)
	lqd	$2,32($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,32($sp)
	lqd	$2,48($sp)
	cwd	$3,0($sp)
	shufb	$2,$5,$2,$3
	stqd	$2,48($sp)
	lqd	$2,64($sp)
	cwd	$3,0($sp)
	shufb	$2,$6,$2,$3
	stqd	$2,64($sp)
	lqd	$2,80($sp)
	cwd	$3,0($sp)
	shufb	$2,$7,$2,$3
	stqd	$2,80($sp)
	lqd	$2,96($sp)
	cwd	$3,0($sp)
	shufb	$2,$8,$2,$3
	stqd	$2,96($sp)
	il	$4,32
	lqd	$2,112($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,112($sp)
	lqd	$2,32($sp)
	wrch	$ch16,$2
	lqd	$2,48($sp)
	wrch	$ch17,$2
	lqd	$2,64($sp)
	wrch	$ch18,$2
	lqd	$2,80($sp)
	wrch	$ch19,$2
	lqd	$2,96($sp)
	wrch	$ch20,$2
	lqd	$2,112($sp)
	wrch	$ch21,$2
	il	$3,1
	lqd	$2,480($sp)
	shl	$2,$3,$2
	wrch	$ch22,$2
	il	$2,1
	wrch	$ch23,$2
	rdch	$2,$ch24
	ori	$4,$2,0
	lqd	$2,128($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,128($sp)
	lqd	$2,320($sp)
	ai	$4,$2,1
	lqd	$2,320($sp)
	cwd	$3,0($sp)
	shufb	$2,$4,$2,$3
	stqd	$2,320($sp)
.L18:
	lqd	$2,544($sp)
	rotqbyi	$3,$2,4
	lqd	$2,320($sp)
	cgt	$2,$3,$2
	brnz	$2,.L19
	lqd	$3,416($sp)
	brsl	$lr,free
	br	.L15
.L14:
	lqd	$3,608($sp)
	il	$2,624
	a	$sp,$sp,$2
	lqd	$lr,16($sp)
	bi	$lr
	.size	main, .-main
	.ident	"GCC: (GNU) 4.0.2 (CELL 3-2, Apr 11 2006)"
